diff -Naur -x .svn stamp-0.9.10/lib/htm_ibm.c stamp-0.9.10_Distribute/lib/htm_ibm.c
--- stamp-0.9.10/lib/htm_ibm.c	1970-01-01 09:00:00.000000000 +0900
+++ stamp-0.9.10_Distribute/lib/htm_ibm.c	2014-12-18 12:21:54.329647772 +0900
@@ -0,0 +1,671 @@
+/* Copyright (c) IBM Corp. 2014. */
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <inttypes.h>
+#include <unistd.h>
+#include "htm_ibm.h"
+#include "htm_util.h"
+#include "thread.h"
+#include "mfence.h"
+#include "tm.h"
+#ifdef __bgq__
+#include <speculation.h>
+#endif
+
+#define NUM_HTM_STATS_EVENTS 14
+#define NUM_HTM_ABORT_REASON_CODES 19
+#define NUM_HTM_TBEGIN_RETURNS 3
+#define NUM_ATOMIC_REGIONS 20
+#ifndef DETECT_DELINQUENTS
+#define DETECT_DELINQUENTS 0
+#endif
+
+enum {
+  event_tx = 0,
+  event_tx_enter,
+  event_abort,
+  event_first_abort,
+  event_global_lock_wait_before_tx_spin,
+  event_global_lock_wait_before_tx_sleep,
+  event_global_lock_wait_and_retry_spin,
+  event_global_lock_wait_and_retry_sleep,
+  event_global_lock_acquired,
+  event_persistent_abort_retry,
+  event_global_lock_persistent_abort,
+  event_transient_abort_retry,
+  event_global_lock_transient_abort,
+  event_detected_delinquent
+};
+
+typedef struct htm_stats_struct {
+  unsigned long long event_counter[NUM_HTM_STATS_EVENTS];
+#if defined(__370__)
+  unsigned long long abort_reason_code[NUM_HTM_ABORT_REASON_CODES][NUM_HTM_TBEGIN_RETURNS];
+#elif defined(__x86_64__)
+#define HTM_IA32_STAT(nam) long long unsigned int nam;
+  struct{
+#include "htm_ia32_stat.h"
+  } abort_reason_counters;
+#undef HTM_IA32_STAT
+#elif defined(__PPC__) || defined(_ARCH_PPC)
+#define HTM_PPC_STAT(NAM) long long unsigned int NAM;
+  struct {
+#include "htm_ppc_stat.h"
+  } abort_reason_counters;
+#undef HTM_PPC_STAT
+#else
+  char dummy;
+#endif
+} htm_stats_t;
+
+typedef struct tls_struct {
+  htm_stats_t htm_stats[NUM_ATOMIC_REGIONS];
+} tls_t;
+
+/*#define USE_MUTEX*/
+
+static union {
+  char two_cache_lines[512];
+  struct {
+    char one_cache_line[256];
+    volatile int global_lock;
+    char another_cache_line[252];
+  } a;
+} gl;
+#ifdef USE_MUTEX
+static THREAD_MUTEX_T global_lock_mutex;
+static THREAD_COND_T global_lock_cond;
+#endif
+static THREAD_KEY_T global_tls_key;
+
+static int transient_retry_max = 16;
+static int persistent_retry_max = 1;
+static int global_lock_retry_max = 16;
+static int collect_stats = 0;
+static htm_stats_t global_htm_stats_per_region[NUM_ATOMIC_REGIONS];
+static htm_stats_t global_htm_stats;
+static THREAD_MUTEX_T global_htm_stats_lock;
+
+
+/*#define ABORTED_INSN_ADDRESS_STATS*/
+#ifdef ABORTED_INSN_ADDRESS_STATS
+#define ABORTED_INSN_ADDRESS_STATS_MAP_SIZE (15 * 1024 * 1024 / 2)
+#define ABORTED_INSN_ADDRESS_STATS_START_ADDRESS 0x13b08000
+/*#define ABORTED_INSN_ADDRESS_STATS_START_ADDRESS 0x25c08000*/
+uint64_t aborted_insn_address_stats[ABORTED_INSN_ADDRESS_STATS_MAP_SIZE];
+uint64_t aborted_insn_address_reason_code;
+#endif
+
+void
+tm_startup_ibm()
+{
+  const char *env_transient_retry_max;
+  const char *env_persistent_retry_max;
+  const char *env_global_lock_retry_max;
+  const char *env_collect_stats;
+#ifdef ABORTED_INSN_ADDRESS_STATS
+  const char *env_aborted_insn_address_reason_code;
+#endif
+
+  gl.a.global_lock = 0;
+#ifdef USE_MUTEX
+  THREAD_MUTEX_INIT(global_lock_mutex);
+  THREAD_COND_INIT(global_lock_cond);
+#endif
+  THREAD_KEY_INIT(global_tls_key);
+
+  env_transient_retry_max = getenv("HTM_TRETRY");
+  if (env_transient_retry_max) {
+#ifdef __bgq__
+    fprintf(stderr, "<HTM_TRETRY has no meaning on Blue Gene/Q>");
+#else
+    transient_retry_max = atoi(env_transient_retry_max);
+    fprintf(stderr, "<HTM_TRETRY=%d>\n", transient_retry_max);
+#endif
+  }
+
+  env_persistent_retry_max = getenv("HTM_PRETRY");
+  if (env_persistent_retry_max) {
+#ifdef __bgq__
+    fprintf(stderr, "<HTM_PRETRY has no meaning on Blue Gene/Q>");
+#else
+    persistent_retry_max = atoi(env_persistent_retry_max);
+    fprintf(stderr, "<HTM_PRETRY=%d>\n", persistent_retry_max);
+#endif
+  }
+
+  env_global_lock_retry_max = getenv("HTM_GRETRY");
+  if (env_global_lock_retry_max) {
+#ifdef __bgq__
+    fprintf(stderr, "<HTM_GRETRY has no meaning on Blue Gene/Q>");
+#else
+    global_lock_retry_max = atoi(env_global_lock_retry_max);
+    fprintf(stderr, "<HTM_GRETRY=%d>\n", global_lock_retry_max);
+#endif
+  }
+
+  env_collect_stats = getenv("HTM_STATS");
+  if (DETECT_DELINQUENTS || env_collect_stats) {
+    collect_stats = 1;
+  }
+
+#ifdef ABORTED_INSN_ADDRESS_STATS
+  env_aborted_insn_address_reason_code = getenv("HTM_AIACODE");
+  if (env_aborted_insn_address_reason_code) {
+    aborted_insn_address_reason_code = (uint64_t)atoi(env_aborted_insn_address_reason_code);
+  }
+#endif
+
+#ifndef __bgq__
+  if (collect_stats) {
+    memset(&global_htm_stats_per_region, 0, sizeof(global_htm_stats_per_region));
+    memset(&global_htm_stats, 0, sizeof(global_htm_stats));
+    THREAD_MUTEX_INIT(global_htm_stats_lock);
+  }
+#endif
+}
+
+static void
+print_stats(htm_stats_t *stats)
+{
+#if defined(__bgq__)
+  TmReport_t bgq_htm_stats;
+
+  tm_get_all_stats(&bgq_htm_stats);
+  printf("#HTM_STATS %15lu totalTransactions\n", bgq_htm_stats.totalTransactions);
+  printf("#HTM_STATS %15lu totalRollbacks\n", bgq_htm_stats.totalRollbacks);
+  printf("#HTM_STATS %15lu totalSerializedJMV\n", bgq_htm_stats.totalSerializedJMV);
+  printf("#HTM_STATS %15lu totalSerializedMAXRB\n", bgq_htm_stats.totalSerializedMAXRB);
+  printf("#HTM_STATS %15lu totalSerializedOTHER\n", bgq_htm_stats.totalSerializedOTHER);
+#else /* ! __bgq__ */
+#if defined(__370__)
+  int i;
+  const char *reason_string[] = {
+    "TDB_not_set",
+    "Restart_interruption",
+    "External_interruption",
+    NULL,
+    "Program_interruption",
+    "Machine-check_interruption",
+    "I/O_interruption",
+    "Fetch_overflow",
+    "Store_overflow",
+    "Fetch_conflict",
+    "Store_conflict",
+    "Restricted_instruction",
+    "Program-interruption_condition",
+    "Nesting_depth_exceeded",
+    "Cache_fetch-related",
+    "Cache_store-related",
+    "Cache_other",
+    "Undetermined_condition",
+    "TABORT_instruction"
+  };
+#endif
+
+  fprintf(stderr, "#HTM_STATS %15llu           tx_enter\n", stats->event_counter[event_tx_enter]);
+  fprintf(stderr, "#HTM_STATS %15llu           tx\n", stats->event_counter[event_tx]);
+  fprintf(stderr, "#HTM_STATS %15llu %6.2f %%  global_lock_wait_before_tx_spin\n", stats->event_counter[event_global_lock_wait_before_tx_spin], 100 * stats->event_counter[event_global_lock_wait_before_tx_spin] / (double)stats->event_counter[event_tx_enter]);
+  fprintf(stderr, "#HTM_STATS %15llu %6.2f %%  global_lock_wait_before_tx_sleep\n", stats->event_counter[event_global_lock_wait_before_tx_sleep], 100 * stats->event_counter[event_global_lock_wait_before_tx_sleep] / (double)stats->event_counter[event_tx_enter]);
+  fprintf(stderr, "#HTM_STATS %15llu %6.2f %%  abort\n", stats->event_counter[event_abort], 100 * stats->event_counter[event_abort] / (double)stats->event_counter[event_tx]);
+  fprintf(stderr, "#HTM_STATS %15llu %6.2f %%  first_abort\n", stats->event_counter[event_first_abort], 100 * stats->event_counter[event_first_abort] / (double)stats->event_counter[event_tx_enter]);
+  fprintf(stderr, "#HTM_STATS %15llu %6.2f %%  global_lock_wait_and_retry_spin\n", stats->event_counter[event_global_lock_wait_and_retry_spin], 100 * stats->event_counter[event_global_lock_wait_and_retry_spin] / (double)stats->event_counter[event_abort]);
+  fprintf(stderr, "#HTM_STATS %15llu %6.2f %%  global_lock_wait_and_retry_sleep\n", stats->event_counter[event_global_lock_wait_and_retry_sleep], 100 * stats->event_counter[event_global_lock_wait_and_retry_sleep] / (double)stats->event_counter[event_abort]);
+  fprintf(stderr, "#HTM_STATS %15llu %6.2f %%  global_lock_acquired\n", stats->event_counter[event_global_lock_acquired], 100 * stats->event_counter[event_global_lock_acquired] / (double)stats->event_counter[event_abort]);
+  fprintf(stderr, "#HTM_STATS %15llu %6.2f %%  persistent_abort_retry\n", stats->event_counter[event_persistent_abort_retry], 100 * stats->event_counter[event_persistent_abort_retry] / (double)stats->event_counter[event_abort]);
+  fprintf(stderr, "#HTM_STATS %15llu %6.2f %%  global_lock_persistent_abort\n", stats->event_counter[event_global_lock_persistent_abort], 100 * stats->event_counter[event_global_lock_persistent_abort] / (double)stats->event_counter[event_abort]);
+  fprintf(stderr, "#HTM_STATS %15llu %6.2f %%  transient_abort_retry\n", stats->event_counter[event_transient_abort_retry], 100 * stats->event_counter[event_transient_abort_retry] / (double)stats->event_counter[event_abort]);
+  fprintf(stderr, "#HTM_STATS %15llu %6.2f %%  global_lock_transient_abort\n", stats->event_counter[event_global_lock_transient_abort], 100 * stats->event_counter[event_global_lock_transient_abort] / (double)stats->event_counter[event_abort]);
+  fprintf(stderr, "#HTM_STATS %15llu %6.2f %%  detected_delinquent\n", stats->event_counter[event_detected_delinquent], 100 * stats->event_counter[event_detected_delinquent] / (double)stats->event_counter[event_tx_enter]);
+
+#if defined(__370__)
+  for (i = 0; i < NUM_HTM_ABORT_REASON_CODES; i++) {
+    if (reason_string[i]) {
+      unsigned long long total = stats->abort_reason_code[i][0] + stats->abort_reason_code[i][1] + stats->abort_reason_code[i][2];
+      fprintf(stderr, "#HTM_STATS %15llu %s\n", total, reason_string[i]);
+    }
+  }
+#elif defined(__x86_64__)
+#define HTM_IA32_STAT(nam) fprintf(stderr, "#HTM_STATS %15llu " #nam "\n", stats->abort_reason_counters.nam );
+#include "htm_ia32_stat.h"
+#undef HTM_IA32_STAT
+#elif defined(__PPC__) || defined(_ARCH_PPC)
+#define HTM_PPC_STAT(nam) fprintf(stderr, "#HTM_STATS %15llu " #nam "\n", stats->abort_reason_counters.nam );
+#include "htm_ppc_stat.h"
+#undef HTM_PPC_STAT
+#endif
+#endif /* ! __bgq__ */
+}
+
+void
+tm_shutdown_ibm()
+{
+  if (collect_stats) {
+#ifndef __bgq__
+    int i;
+    int region;
+
+    for (region = 0; region < NUM_ATOMIC_REGIONS; region++) {
+      for (i = 0; i < NUM_HTM_STATS_EVENTS; i++) {
+	global_htm_stats.event_counter[i] += global_htm_stats_per_region[region].event_counter[i];
+      }
+#if defined(__370__)
+      for (i = 0; i < NUM_HTM_ABORT_REASON_CODES; i++) {
+	int j;
+	for (j = 0; j < NUM_HTM_TBEGIN_RETURNS; j++) {
+	  global_htm_stats.abort_reason_code[i][j] += global_htm_stats_per_region[region].abort_reason_code[i][j];
+	}
+      }
+#elif defined(__x86_64__)
+#define HTM_IA32_STAT(nam) global_htm_stats.abort_reason_counters.nam += global_htm_stats_per_region[region].abort_reason_counters.nam;
+#include "htm_ia32_stat.h"
+#undef HTM_IA32_STAT
+#elif defined(__PPC__) || defined(_ARCH_PPC)
+#define HTM_PPC_STAT(nam) global_htm_stats.abort_reason_counters.nam += global_htm_stats_per_region[region].abort_reason_counters.nam;
+#include "htm_ppc_stat.h"
+#undef HTM_PPC_STAT
+#endif
+    }
+#endif /* ! __bgq__ */
+
+    print_stats(&global_htm_stats);
+    if (getenv("HTM_STATS_PER_REGION")) {
+#ifdef __bgq__
+      fprintf(stderr, "<HTM_STATS_PER_REGION is not supported on Blue Gene/Q>\n");
+#else
+      for (region = 0; region < NUM_ATOMIC_REGIONS; region++) {
+	if (global_htm_stats_per_region[region].event_counter[event_tx] != 0) {
+	  fprintf(stderr, "--- region %d ------------------------------\n", region);
+	  print_stats(&global_htm_stats_per_region[region]);
+	}
+      }
+#endif
+    }
+  }
+
+#ifdef ABORTED_INSN_ADDRESS_STATS
+  {
+    int insn_addr;
+    for (insn_addr = 0; insn_addr < ABORTED_INSN_ADDRESS_STATS_MAP_SIZE; insn_addr++) {
+      if (aborted_insn_address_stats[insn_addr] != 0) {
+	fprintf(stderr, "ABORTED_INSN_ADDRESS %" PRIx64 " %x %" PRIu64 "\n", (uint64_t)(ABORTED_INSN_ADDRESS_STATS_START_ADDRESS + insn_addr * 2), insn_addr * 2, aborted_insn_address_stats[insn_addr]);
+      }
+    }
+  }
+#endif
+
+  if (getenv("LOOP_AT_END")) {
+    for ( ; ; ) {
+      sleep(3600);
+    }
+  }
+}
+
+void
+tm_thread_enter_ibm()
+{
+#ifndef __bgq__
+  tls_t *tls;
+
+  tls = malloc(sizeof(tls_t));
+  if (tls == NULL) {
+    fprintf(stderr, "malloc error\n");
+    exit(1);
+  }
+  memset(tls, 0, sizeof(tls_t));
+
+  THREAD_KEY_SET(global_tls_key, tls);
+#endif /* ! __bgq__ */
+}
+
+void
+tm_thread_exit_ibm()
+{
+#ifndef __bgq__
+  if (collect_stats) {
+    tls_t *tls;
+    int i;
+    int region;
+
+    tls = THREAD_KEY_GET(global_tls_key);
+
+    THREAD_MUTEX_LOCK(global_htm_stats_lock);
+    for (region = 0; region < NUM_ATOMIC_REGIONS; region++) {
+      for (i = 0; i < NUM_HTM_STATS_EVENTS; i++) {
+	global_htm_stats_per_region[region].event_counter[i] += tls->htm_stats[region].event_counter[i];
+      }
+#if defined(__370__)
+      for (i = 0; i < NUM_HTM_ABORT_REASON_CODES; i++) {
+	int j;
+	for (j = 0; j < NUM_HTM_TBEGIN_RETURNS; j++) {
+	  global_htm_stats_per_region[region].abort_reason_code[i][j] += tls->htm_stats[region].abort_reason_code[i][j];
+	}
+      }
+#elif defined(__x86_64__)
+#define HTM_IA32_STAT(nam) global_htm_stats_per_region[region].abort_reason_counters.nam += tls->htm_stats[region].abort_reason_counters.nam;
+#include "htm_ia32_stat.h"
+#undef HTM_IA32_STAT
+#elif defined(__PPC__) || defined(_ARCH_PPC)
+#define HTM_PPC_STAT(nam) global_htm_stats_per_region[region].abort_reason_counters.nam += tls->htm_stats[region].abort_reason_counters.nam;
+#include "htm_ppc_stat.h"
+#undef HTM_PPC_STAT
+#endif
+    }
+    THREAD_MUTEX_UNLOCK(global_htm_stats_lock);
+  }
+#endif /* ! __bgq__ */
+}
+
+static int
+fall_back_global_lock(int acquire)
+{
+#ifdef USE_MUTEX
+  const int spin_max = 2000000000;
+  int spin_count = spin_max;
+  while (gl.a.global_lock && --spin_count > 0)
+    ;
+  if (! acquire && ! gl.a.global_lock) {
+    return 0;
+  }
+
+  THREAD_MUTEX_LOCK(global_lock_mutex);
+  while (gl.a.global_lock) {
+    THREAD_COND_WAIT(global_lock_cond, global_lock_mutex);
+  }
+  gl.a.global_lock = 1;
+  THREAD_MUTEX_UNLOCK(global_lock_mutex);
+
+  return 1;
+#else /* !USE_MUTEX */
+#if defined(__370__)
+  cs_t local_value = 0;
+  cs_t new_value = 1;
+#endif
+
+  while (gl.a.global_lock)
+    ;
+  if (! acquire)
+    return 0;
+
+#if defined(__370__)
+  while (cs(&local_value, (cs_t *)&gl.a.global_lock, new_value)) {
+    while (local_value = gl.a.global_lock)
+      ;
+  }
+#elif defined(__IBMC__)
+  memory_fence();
+  while(__check_lock_mp(&gl.a.global_lock, 0, 1));
+  memory_fence();
+#elif defined(__GNUC__)
+  while (__sync_val_compare_and_swap(&gl.a.global_lock, 0, 1)) {
+    while (gl.a.global_lock)
+      ;
+  }
+#else
+#error
+#endif
+
+  return 1;
+#endif /* USE_MUTEX */
+}
+
+#define INCREMENT_STAT(field)				\
+  do {							\
+    if (collect_stats) {				\
+      tls->htm_stats[region_id].event_counter[event_ ## field]++;	\
+    }							\
+  } while (0)
+
+static int isAbortPersistent(int tbegin_result,TransactionDiagnosticInfo *diag) {
+#if defined(__370__)
+  uint64_t reason=diag->transactionAbortCode;
+  return (tbegin_result != 4 &&
+	  (diag->format != 1 || reason == 7 || reason == 8 || (11 <= reason && reason <= 13)));
+#elif defined(__x86_64__)
+  return ( (tbegin_result != 4) && !(diag->transactionAbortCode&XABORT_RETRY));
+#elif defined(__PPC__) || defined(_ARCH_PPC)
+  return (tbegin_result != 4) && (diag->transactionAbortCode&0x0100000000000000ULL);
+#else
+  return 0;
+#endif
+}
+
+static int isTransactionDelinquent(htm_stats_t* stats) {
+  static const long long min_tx_before_detection=1000;
+  static const long long delinquent_abort_threshold=80;
+  long long abort_ratio;
+  int res=0;
+  if(min_tx_before_detection<(stats->event_counter[event_tx])) {
+    abort_ratio=(100LL* stats->event_counter[event_abort]) / stats->event_counter[event_tx];
+    if(abort_ratio>delinquent_abort_threshold) {
+      res=1;
+    }
+  }
+  return res;
+}
+
+/*#define ABORT_CC_AND_RETRY_STATS*/
+
+void
+tbegin_ibm(int region_id)
+{
+  int tbegin_result;
+  TransactionDiagnosticInfo diag;
+  int transient_retry_count;
+  int persistent_retry_count;
+  int global_lock_retry_count;
+  tls_t *tls = NULL;
+  int first_retry;
+#if defined(__370__)
+  uint64_t saved_fprs[8];  /* FPR8 - FPR15 */
+#endif
+#ifdef ABORT_CC_AND_RETRY_STATS
+  uint64_t saved_reason = 0; uint8_t saved_LSUAbortCode = 0; int saved_tbegin_result = 0;
+#endif
+
+  if (collect_stats) {
+    tls = THREAD_KEY_GET(global_tls_key);
+  }
+
+  INCREMENT_STAT(tx_enter);
+
+  /* Do not use HTM for delinquent transactions */
+  if(DETECT_DELINQUENTS && isTransactionDelinquent(&(tls->htm_stats[region_id]))) {
+    fall_back_global_lock(1);
+    INCREMENT_STAT(detected_delinquent);
+    return;
+  }
+
+  if (gl.a.global_lock) {
+    if (fall_back_global_lock(0)) {
+      INCREMENT_STAT(global_lock_wait_before_tx_sleep);
+      return;
+    }
+    INCREMENT_STAT(global_lock_wait_before_tx_spin);
+  }
+
+  transient_retry_count = transient_retry_max;
+  persistent_retry_count = persistent_retry_max;
+  global_lock_retry_count = global_lock_retry_max;
+  first_retry = 1;
+#if defined(__370__)
+  save_preserved_fpr(saved_fprs);
+#endif
+ tx_retry:
+  INCREMENT_STAT(tx);
+  tbegin_result = tbegin(&diag);
+  if (tbegin_result == 0) {
+    /* Transaction */
+    if (gl.a.global_lock) {
+      tend();
+      tbegin_result = 4;
+    }
+#ifdef HTM_CONSERVE_RWBUF
+    else {
+      suspend_tx();
+    }
+#endif
+  }
+  if (tbegin_result != 0) {
+    /* Abort */
+    uint64_t reason = diag.transactionAbortCode;
+    /*int saved_first_retry;*/
+
+    if (tbegin_result != 4) {
+#if defined(__370__)
+      restore_preserved_fpr(saved_fprs);
+#endif
+    }
+
+#ifdef ABORT_CC_AND_RETRY_STATS
+    if (global_lock_retry_count == global_lock_retry_max
+	&& reason == saved_reason && diag.LSUAbortCode == saved_LSUAbortCode && tbegin_result == saved_tbegin_result) {
+      printf("AbortCcAndRetryStats r %d %llu %u %d\n", transient_retry_count, saved_reason, saved_LSUAbortCode, saved_tbegin_result);
+    }
+#endif
+
+    INCREMENT_STAT(abort);
+    /*saved_first_retry = first_retry;*/
+    if (first_retry) {
+      first_retry = 0;
+      INCREMENT_STAT(first_abort);
+    }
+
+    if (gl.a.global_lock) {
+      if (--global_lock_retry_count > 0) {
+	if (fall_back_global_lock(0)) {
+	  INCREMENT_STAT(global_lock_wait_and_retry_sleep);
+	  return;
+	}
+	INCREMENT_STAT(global_lock_wait_and_retry_spin);
+	goto tx_retry;
+      }
+      INCREMENT_STAT(global_lock_acquired);
+      fall_back_global_lock(1);
+    } else {
+      if (collect_stats /*&& saved_first_retry*/) {
+#if defined(__370__)
+	if (tbegin_result == 4) {
+	  tls->htm_stats[region_id].abort_reason_code[18][1]++;
+	} else if (diag.format != 1) {
+	  tls->htm_stats[region_id].abort_reason_code[0][tbegin_result - 1]++;
+	} else if (reason <= 16) {
+	  tls->htm_stats[region_id].abort_reason_code[reason][tbegin_result - 1]++;
+	} else if (reason == 255) {
+	  tls->htm_stats[region_id].abort_reason_code[17][tbegin_result - 1]++;
+	} else {
+	  tls->htm_stats[region_id].abort_reason_code[18][tbegin_result - 1]++;
+	}
+#elif defined(__x86_64__)
+#define TLSCTR tls->htm_stats[region_id].abort_reason_counters
+	if(tbegin_result==4) {
+	  TLSCTR.GLOBAL_LOCK_ACQUIRED ++;
+	} else {
+	  TLSCTR.XABORT                    += (reason&XABORT_EXPLICIT)?1L:0L;
+	  TLSCTR.TRANSIENT                 += (reason&XABORT_RETRY)?1L:0L;
+	  TLSCTR.MEMADDR_CONFLICT          += (reason&XABORT_CONFLICT)?1L:0L;
+	  TLSCTR.BUFFER_OVERFLOW           += (reason&XABORT_CAPACITY)?1L:0L;
+	  TLSCTR.HIT_DEBUG_BREAKPOINT      += (reason&XABORT_DEBUG)?1L:0L;
+	  TLSCTR.DURING_NESTED_TRANSACTION += (reason&XABORT_NESTED)?1L:0L;
+	}
+#elif defined(__PPC__) || defined(_ARCH_PPC)
+#define TLSCTR tls->htm_stats[region_id].abort_reason_counters
+#define PPC_BFIELD(x) ((0x1ULL)<<(63-x))
+	if(tbegin_result==4) {
+	  TLSCTR.Global_Lock_Acquired ++;
+	} else {
+	  TLSCTR.Failure_Persistent                += (reason&PPC_BFIELD( 7))?1:0;
+	  TLSCTR.Disallowed                        += (reason&PPC_BFIELD( 8))?1:0;
+	  TLSCTR.Nesting_Overflow                  += (reason&PPC_BFIELD( 9))?1:0;
+	  TLSCTR.Footprint_Overflow                += (reason&PPC_BFIELD(10))?1:0;
+	  TLSCTR.Self_Induced_Conflict             += (reason&PPC_BFIELD(11))?1:0;
+	  TLSCTR.Non_Transactional_Conflict        += (reason&PPC_BFIELD(12))?1:0;
+	  TLSCTR.Transaction_Conflict              += (reason&PPC_BFIELD(13))?1:0;
+	  TLSCTR.Translation_Invalidation_Conflict += (reason&PPC_BFIELD(14))?1:0;
+	  TLSCTR.Implementation_Specific           += (reason&PPC_BFIELD(15))?1:0;
+	  TLSCTR.Instruction_Fetch_Conflict        += (reason&PPC_BFIELD(16))?1:0;
+	}
+#endif
+      }
+
+#ifdef ABORTED_INSN_ADDRESS_STATS
+      if (reason == aborted_insn_address_reason_code) {
+	int idx;
+
+	if (diag.abortedTransactionInstructionAddress < ABORTED_INSN_ADDRESS_STATS_START_ADDRESS) {
+	  idx = 0;
+	} else {
+	  idx = (diag.abortedTransactionInstructionAddress - ABORTED_INSN_ADDRESS_STATS_START_ADDRESS) / 2;
+	  if (idx >= ABORTED_INSN_ADDRESS_STATS_MAP_SIZE)
+	    idx = ABORTED_INSN_ADDRESS_STATS_MAP_SIZE - 1;
+	}
+	aborted_insn_address_stats[idx]++;
+      }
+#endif
+
+#ifdef ABORT_CC_AND_RETRY_STATS
+      if (global_lock_retry_count == global_lock_retry_max
+	  && (transient_retry_count == transient_retry_max ||
+	      reason == saved_reason && diag.LSUAbortCode == saved_LSUAbortCode && tbegin_result == saved_tbegin_result)) {
+	printf("AbortCcAndRetryStats f %d %llu %u %d\n", transient_retry_count, reason, diag.LSUAbortCode, tbegin_result);
+	saved_reason = reason; saved_LSUAbortCode = diag.LSUAbortCode; saved_tbegin_result = tbegin_result;
+      } else {
+	saved_reason = 0; saved_LSUAbortCode = 0; saved_tbegin_result = 0;
+      }
+#else /* ABORT_CC_AND_RETRY_STATS */
+      if (isAbortPersistent(tbegin_result,&diag)) {
+	/* Persistent abort */
+	if (--persistent_retry_count > 0) {
+	  INCREMENT_STAT(persistent_abort_retry);
+	  goto tx_retry;
+	}
+	INCREMENT_STAT(global_lock_persistent_abort);
+	fall_back_global_lock(1);
+      } else
+#endif /* ! ABORT_CC_AND_RETRY_STATS */
+      {
+	/* Transient abort */
+	if (--transient_retry_count > 0) {
+	  INCREMENT_STAT(transient_abort_retry);
+	  goto tx_retry;
+	}
+	INCREMENT_STAT(global_lock_transient_abort);
+	fall_back_global_lock(1);
+      }
+    }
+  }
+}
+
+
+void
+tend_ibm()
+{
+#ifdef HTM_CONSERVE_RWBUF
+  resume_tx();
+#endif
+  if (gl.a.global_lock) {
+#ifdef USE_MUTEX
+    THREAD_MUTEX_LOCK(global_lock_mutex);
+    gl.a.global_lock = 0;
+    THREAD_COND_SIGNAL(global_lock_cond);
+    THREAD_MUTEX_UNLOCK(global_lock_mutex);
+#else
+    memory_fence();
+#if !defined(__370__) && defined(__IBMC__)
+    __clear_lock_mp(&gl.a.global_lock,0);
+#else
+    gl.a.global_lock = 0;
+#endif /* __IBMC__ */
+#endif
+    /*memory_fence();*/
+  } else {
+    tend();
+  }
+}
+
+void
+tabort_ibm()
+{
+  tabort(300);
+}
diff -Naur -x .svn stamp-0.9.10/lib/htm_ibm.h stamp-0.9.10_Distribute/lib/htm_ibm.h
--- stamp-0.9.10/lib/htm_ibm.h	1970-01-01 09:00:00.000000000 +0900
+++ stamp-0.9.10_Distribute/lib/htm_ibm.h	2014-12-18 12:21:57.928724071 +0900
@@ -0,0 +1,15 @@
+/* Copyright (c) IBM Corp. 2014. */
+#ifndef HTM_IBM_H
+#define HTM_IBM_H 1
+
+extern void tm_startup_ibm();
+extern void tm_shutdown_ibm();
+
+extern void tm_thread_enter_ibm();
+extern void tm_thread_exit_ibm();
+
+extern void tbegin_ibm(int region_id);
+extern void tend_ibm();
+extern void tabort_ibm();
+
+#endif
diff -Naur -x .svn stamp-0.9.10/lib/htm_ppc_stat.h stamp-0.9.10_Distribute/lib/htm_ppc_stat.h
--- stamp-0.9.10/lib/htm_ppc_stat.h	1970-01-01 09:00:00.000000000 +0900
+++ stamp-0.9.10_Distribute/lib/htm_ppc_stat.h	2014-12-18 12:22:03.080695529 +0900
@@ -0,0 +1,13 @@
+/* Copyright (c) IBM Corp. 2014. */
+HTM_PPC_STAT(Global_Lock_Acquired)
+/* See 5.4.2 */
+HTM_PPC_STAT(Failure_Persistent)
+HTM_PPC_STAT(Disallowed)
+HTM_PPC_STAT(Nesting_Overflow)
+HTM_PPC_STAT(Footprint_Overflow)
+HTM_PPC_STAT(Self_Induced_Conflict)
+HTM_PPC_STAT(Non_Transactional_Conflict)
+HTM_PPC_STAT(Transaction_Conflict)
+HTM_PPC_STAT(Translation_Invalidation_Conflict)
+HTM_PPC_STAT(Implementation_Specific)
+HTM_PPC_STAT(Instruction_Fetch_Conflict)
diff -Naur -x .svn stamp-0.9.10/lib/htm_util.c stamp-0.9.10_Distribute/lib/htm_util.c
--- stamp-0.9.10/lib/htm_util.c	1970-01-01 09:00:00.000000000 +0900
+++ stamp-0.9.10_Distribute/lib/htm_util.c	2014-12-18 12:22:09.493623112 +0900
@@ -0,0 +1,239 @@
+/* Copyright (c) IBM Corp. 2014. */
+#include <stdio.h>
+#include <stdint.h>
+#include <assert.h>
+#include "htm_util.h"
+
+#if defined(__370__)
+
+static int tbegin_impl(void *diag);
+#if 1
+/* lghi gpr3,0; tbegin 0(gpr1),FF00; brc 0x8,$+16; lghi gpr3,2; brc 0x6,$+8; lghi gpr3,3 */
+#pragma mc_func tbegin_impl {"A7390000" "E5601000FF00" "A7840008" "A7390002" "A7640004" "A7390003"}
+#else
+/* lghi gpr3,0; tbegin 0(gpr1),FF00; brc 0x8,$+24; lghi gpr3,1; brc 0x4,$+16; lghi gpr3,2; brc 0x2,$+8; lghi gpr3,3 */
+#pragma mc_func tbegin_impl {"A7390000" "E5601000FF00" "A784000C" "A7390001" "A7440008" "A7390002" "A7240004" "A7390003"}
+#endif
+
+static int tbegin_fp_impl(void *diag);
+#if 1
+#pragma mc_func tbegin_fp_impl {"A7390000" "E5601000FF04" "A7840008" "A7390002" "A7640004" "A7390003"}
+#else
+#pragma mc_func tbegin_fp_impl {"A7390000" "E5601000FF04" "A784000C" "A7390001" "A7440008" "A7390002" "A7240004" "A7390003"}
+#endif
+
+static void tend_impl(void *diag);
+#pragma mc_func tend_impl {"B2F81000"}  /* tend 0(gpr1) */
+
+static void ctend_impl(volatile int64_t *addr);
+#pragma mc_func ctend_impl {"E30010000028"}  /* ctend 0(gpr1) */
+
+static void tabort_impl(int code);
+#pragma mc_func tabort_impl {"B2FC1000"}  /* tabort 0(gpr1) */
+
+static void tabort_no_abend_in_no_tx_impl(int code);
+/* tbegin 0(gpr0),FF00; brc 0x7,$+8; tabort 0(gpr1) */
+#pragma mc_func tabort_no_abend_in_no_tx_impl {"E5600000FF00" "A7740004" "B2FC1000"}
+
+static void non_tx_store_impl(int64_t *addr, int64_t data);
+#pragma mc_func non_tx_store_impl { "E32010000025" }  /* ntstg gpr2,0(gpr1) */
+
+static uint64_t
+get_transaction_nesting_depth_impl();
+#pragma mc_func get_transaction_nesting_depth_impl { "B2EC0030" }  /* ETNDG gpr3 */
+
+/* std fpr8,0(gpr1); ...; std fpr15,56(gpr1) */
+static void save_preserved_fpr_impl(uint64_t *addr);
+#pragma mc_func save_preserved_fpr_impl {"60801000" "60901008" "60A01010" "60B01018" "60C01020" "60D01028" "60E01030" "60F01038"}
+
+/* ld fpr8,0(gpr1); ...; ld fpr15,56(gpr1) */
+static void restore_preserved_fpr_impl(uint64_t *addr);
+#pragma mc_func restore_preserved_fpr_impl {"68801000" "68901008" "68A01010" "68B01018" "68C01020" "68D01028" "68E01030" "68F01038"}
+
+int
+tbegin(TransactionDiagnosticInfo *diag)
+{
+  /*return tbegin_impl(diag);*/
+  return tbegin_fp_impl(diag);
+}
+
+#if defined(__370__) && __COMPILER_VER__ >= 0x410d0000
+/* Macro-expanded to intrinsic */
+#else
+void
+tend(void)
+{
+  TransactionDiagnosticInfo *diag = NULL;
+  tend_impl(diag);
+}
+#endif
+
+void
+ctend(volatile int64_t *addr)
+{
+  ctend_impl(addr);
+}
+
+void
+tabort(uint64_t code)
+{
+  tabort_impl(code);
+}
+
+void
+tabort_no_abend_in_no_tx(uint64_t code)
+{
+  tabort_no_abend_in_no_tx_impl(code);
+}
+
+#if defined(__370__) && __COMPILER_VER__ >= 0x410d0000
+/* Macro-expanded to intrinsic */
+#else
+void
+non_tx_store(int64_t *addr, int64_t data)
+{
+  /* addr must be 8-byte aligned */
+  non_tx_store_impl(addr, data);
+}
+#endif
+
+#if defined(__370__) && __COMPILER_VER__ >= 0x410d0000
+/* Macro-expanded to intrinsic */
+#else
+int
+get_transaction_nesting_depth(void)
+{
+  uint64_t ret;
+
+  ret = get_transaction_nesting_depth_impl();
+  return ret & 0xFFFF;
+}
+#endif
+
+void
+save_preserved_fpr(uint64_t *addr)
+{
+  save_preserved_fpr_impl(addr);
+}
+
+void
+restore_preserved_fpr(uint64_t *addr)
+{
+  restore_preserved_fpr_impl(addr);
+}
+
+#elif defined(__x86_64__)  /* __370__ */
+
+/* Everything is in htm_util.h */
+
+#elif defined(__PPC__) || defined(_ARCH_PPC)
+
+/* Everything is in htm_util.h */
+
+#else /* __370__ , __x86_64, __PPC__ */
+
+#error
+
+#endif  /* __370__ -> __x86_64 -> __PPC__ */
+
+void
+countHTMFailures(TransactionDiagnosticInfo *diag, uint64_t *counters)
+{
+#if defined(__370__)
+  uint64_t abortCode = diag->transactionAbortCode;
+  if (diag->format != 1) {
+    counters[0]++;
+  } else if (abortCode <= 2) {
+    counters[abortCode]++;
+    /* No such abort code as 3  */
+  } else if (abortCode <= 17) {
+    counters[abortCode - 1]++;
+  } else if (abortCode == 255) {
+    counters[17]++;
+  } else {
+    counters[18]++;
+  }
+#elif defined(__x86_64__)
+  uint64_t abortCode = diag->transactionAbortCode;
+  counters[0] += (abortCode & XABORT_EXPLICIT) ? 1 : 0;
+  counters[1] += (abortCode & XABORT_RETRY) ? 1 : 0;
+  counters[2] += (abortCode & XABORT_CONFLICT) ? 1 : 0;
+  counters[3] += (abortCode & XABORT_CAPACITY) ? 1 : 0;
+  counters[4] += (abortCode & XABORT_DEBUG) ? 1 : 0;
+  counters[5] += (abortCode & XABORT_NESTED) ? 1 : 0;
+  counters[6] += (abortCode & (XABORT_EXPLICIT | XABORT_RETRY | XABORT_CONFLICT | XABORT_CONFLICT | XABORT_DEBUG | XABORT_NESTED)) ? 0 : 1;  /* Other */
+#elif defined(__PPC__) || defined(_ARCH_PPC)
+  uint64_t texasr = diag->transactionAbortCode;
+#define PPC_BFIELD(x) ((0x1ULL)<<(63-x))
+  counters[ 0] += (texasr & PPC_BFIELD( 7))? 1 : 0;
+  counters[ 1] += (texasr & PPC_BFIELD( 8))? 1 : 0;
+  counters[ 2] += (texasr & PPC_BFIELD( 9))? 1 : 0;
+  counters[ 3] += (texasr & PPC_BFIELD(10))? 1 : 0;
+  counters[ 4] += (texasr & PPC_BFIELD(11))? 1 : 0;
+  counters[ 5] += (texasr & PPC_BFIELD(12))? 1 : 0;
+  counters[ 6] += (texasr & PPC_BFIELD(13))? 1 : 0;
+  counters[ 7] += (texasr & PPC_BFIELD(14))? 1 : 0;
+  counters[ 8] += (texasr & PPC_BFIELD(15))? 1 : 0;
+  counters[ 9] += (texasr & PPC_BFIELD(16))? 1 : 0;
+  counters[10] += (texasr & PPC_BFIELD(31))? 1 : 0;
+  counters[11] += (texasr & (PPC_BFIELD(7) | PPC_BFIELD(8) | PPC_BFIELD(9) | PPC_BFIELD(10) | PPC_BFIELD(11) | PPC_BFIELD(12) | PPC_BFIELD(13) | PPC_BFIELD(14) | PPC_BFIELD(15) | PPC_BFIELD(16) | PPC_BFIELD(31))) ? 0 : 1;  /* Other */
+#else
+#error
+#endif
+}
+
+const char *
+getHTMFailureName(int id)
+{
+  const char *reason_strings[] = {
+#if defined(__370__)
+    "TDB_not_set",
+    "Restart_interruption",
+    "External_interruption",
+    "Program_interruption",
+    "Machine-check_interruption",
+    "I/O_interruption",
+    "Fetch_overflow",
+    "Store_overflow",
+    "Fetch_conflict",
+    "Store_conflict",
+    "Restricted_instruction",
+    "Program-interruption_condition",
+    "Nesting_depth_exceeded",
+    "Cache_fetch-related",
+    "Cache_store-related",
+    "Cache_other",
+    "CTEND_abort",
+    "Miscellaneous_condition",
+    "TABORT_instruction"
+#elif defined(__x86_64__)
+    "XABORT",
+    "TRANSIENT",
+    "MEMADDR_CONFLICT",
+    "BUFFER_OVERFLOW",
+    "HIT_DEBUG_BREAKPOINT",
+    "DURING_NESTED_TRANSACTION",
+    "OTHER"
+#elif defined(__PPC__) || defined(_ARCH_PPC)
+    "Failure_Persistent",
+    "Disallowed",
+    "Nesting_Overflow",
+    "Footprint_Overflow",
+    "Self_Induced_Conflict",
+    "Non_Tx_Conflict",
+    "Tx_Conflict",
+    "Translation_Invalidation",
+    "Implementation_Specific",
+    "Instruction_Fetch_Conflict",
+    "Tabort_Treclaim",
+    "Other"
+#else
+#error
+#endif
+  };
+
+  if (id < 0 || NUM_HTM_FAILURE_REASONS <= id) {
+    return NULL;
+  }
+  return reason_strings[id];
+}
